#include <cassert>
#include <cmath>
#include <cstdio>
#include <cstdlib>
#include <cstring>

#define TASKNAME "distance"

const int MaxN = 10000, MaxM = 100000, MaxM2 = MaxM * 2;
const int MaxC = 0x3F3F3F3F, NA = -1;

int b [MaxM2], e [MaxM2], len [MaxM2], next [MaxM2];
int a [MaxN];
int h [MaxN + 1], r [MaxN + 1];
int w [MaxN];
bool d [MaxN];
int m, n, s;
int x, y;

void minheapup (int i)
{
 int j, x;
 x = a[i];
 while (1)
 {
  j = i >> 1;
  if (j == 0) break;
  if (w[a[j]] <= w[x]) break;
  a[i] = a[j];
  r[a[i]] = i;
  i = j;
 }
 a[i] = x;
 r[a[i]] = i;
}

void minheapdown (int i)
{
 if (s == 0) return;
 int j, x;
 x = a[i];
 while (1)
 {
  j = i << 1;
  if (j > s) break;
  if (j < s && w[a[j + 1]] < w[a[j]]) j++;
  if (w[a[j]] >= w[x]) break;
  a[i] = a[j];
  r[a[i]] = i;
  i = j;
 }
 a[i] = x;
 r[a[i]] = i;
}

void addvertex (int v)
{
 int i, k;
 for (i = a[v]; i != NA; i = next[i])
 {
  k = e[i];
  if (d[k]) continue;
  if (r[k] == NA)
  {
   w[k] = w[v] + len[i];
   s++;
   h[s] = k;
   minheapup (s);
  }
  else if (w[k] > w[v] + len[i])
  {
   w[k] = w[v] + len[i];
   minheapup (r[k]);
  }
 }
}

int main (void)
{
 int i, j, k, l;
 freopen (TASKNAME ".in", "rt", stdin);
 freopen (TASKNAME ".out", "wt", stdout);
 while (scanf (" %d %d", &n, &m) != EOF)
 {
  scanf (" %d %d", &x, &y);
  x--; y--;
  memset (a, NA, sizeof (a));
  for (i = 0; i < m; i++)
  {
   scanf (" %d %d %d", &j, &k, &l);
   j--; k--;
   len[i] = l;
   b[i] = j;
   e[i] = k;
   next[i] = a[j];
   a[j] = i;
   len[i + m] = l;
   b[i + m] = k;
   e[i + m] = j;
   next[i + m] = a[k];
   a[k] = i + m;
  }

  memset (w, MaxC, sizeof (w));
  memset (d, false, sizeof (d));
  w[x] = 0;

  memset (r, NA, sizeof (r));
  k = x;
  s = 1;
  h[s] = k;
  r[k] = s;
  while (1)
  {
   k = h[1];
   if (k == y) break;
   r[k] = NA;
   d[k] = true;
   h[1] = h[s];
   s--;
   minheapdown (1);
   addvertex (k);
   if (s == 0) break;
  }
  if (w[y] == MaxC) w[y] = NA;
  printf ("%d\n", w[y]);
 }
 return 0;
}
