#include <cassert>
#include <cmath>
#include <cstdio>
#include <cstdlib>
#include <cstring>

#define TASKNAME "road"

const int MaxN = 100000, MaxK = 26, MaxL = 1 << MaxK, MOVE = 5;

char s [MaxN];
int a [MaxK];
unsigned int f [MaxL >> MOVE];

int main (void)
{
 int i, j, k, l, m, n;
 freopen (TASKNAME ".in", "rt", stdin);
 freopen (TASKNAME ".out", "wt", stdout);
 while (scanf (" %d", &k) != EOF)
 {
  scanf (" %s", s);
  n = strlen (s);
  memset (a, 0, sizeof (a));
  m = MaxL - 1;
  for (i = 0; i < k; i++)
  {
   j = s[i] - 'A';
   assert (j >= 0 && j < MaxK);
   if (a[j] == 0) m ^= 1 << j;
   a[j]++;
  }
  memset (f, 0, sizeof (f));
  f[m >> MOVE] |= 1 << m;
  for ( ; i < n; i++)
  {
   j = s[i - k] - 'A';
   a[j]--;
   if (a[j] == 0) m ^= 1 << j;
   j = s[i] - 'A';
   assert (j >= 0 && j < MaxK);
   if (a[j] == 0) m ^= 1 << j;
   a[j]++;
   f[m >> MOVE] |= 1 << m;
  }
  l = -1; m = MaxK + 1;

  for (i = MaxL - 1; i >= 0; i--)
   if (f[i >> MOVE] & (1 << i))
   {
#define doit(j) \
    if (i & (1 << j)) f[(i - (1 << j)) >> MOVE] |= 1 << (i - (1 << j))
    doit (25);
    doit (24);
    doit (23);
    doit (22);
    doit (21);
    doit (20);
    doit (19);
    doit (18);
    doit (17);
    doit (16);
    doit (15);
    doit (14);
    doit (13);
    doit (12);
    doit (11);
    doit (10);
    doit ( 9);
    doit ( 8);
    doit ( 7);
    doit ( 6);
    doit ( 5);
    doit ( 4);
    doit ( 3);
    doit ( 2);
    doit ( 1);
    doit ( 0);
   }
   else
   {
    j = (i & 0x55555555) + ((i & 0xAAAAAAAA) >> 1);
    j = (j & 0x33333333) + ((j & 0xCCCCCCCC) >> 2);
    j = (j & 0x0F0F0F0F) + ((j & 0xF0F0F0F0) >> 4);
    j = (j & 0x00FF00FF) + ((j & 0xFF00FF00) >> 8);
    j = (j & 0x0000FFFF) + ((j & 0xFFFF0000) >> 16);
//    The following feature works slightly slower for me (MinGW GCC 3.4.5):
//    j = __builtin_popcount (i);
    if (m > j)
    {
     m = j;
     l = i;
    }
   }
  assert (l > 0);
  printf ("%d\n", m);
  for (j = 0; j < MaxK; j++)
   if (l & (1 << j))
    printf ("%c\n", char (j + 'A'));
 }
 return 0;
}
