program ADistance;

{$APPTYPE CONSOLE}
{$O+,Q-,R-}

uses
  SysUtils;

procedure Swap(Var A, B:Longint);
var T:Longint;
begin
T := A;
A := B;
B := T;
end;

var
  N, M:Longint;
  A, B, L:Array[1..200000] Of Longint;
  nA, nB, nL:Array[1..200000] Of Longint;

procedure MergeSort(S, E:Longint);
var P1, P2, P3, nP, M:Longint;
begin
If (S >= E) Then Exit;
M := (S + E) Div 2;
MergeSort (S, M);
MergeSort (M + 1, E);

P1 := S; P2 := M + 1;
For P3 := S To E Do Begin
  If (P1 <= M) Then Begin
    If (P2 <= E) Then Begin
      If A[P1] <= A[P2] Then Begin
        nP := P1;
        P1 := P1 + 1;
      End Else Begin
        nP := P2;
        P2 := P2 + 1;
      End;
    End Else Begin
      nP := P1;
      P1 := P1 + 1;
    End;
  End Else Begin
    nP := P2;
    P2 := P2 + 1;
  End;
  nA[P3] := A[nP];
  nB[P3] := B[nP];
  nL[P3] := L[nP];
End;

For P3 := S To E Do Begin
  A[P3] := nA[P3];
  B[P3] := nB[P3];
  L[P3] := nL[P3];
End;
end;

var
  Heap:Array[1..10000] Of Longint;
  HI, IH:Array[1..10000] Of Longint;
  HC:Longint;

procedure ChangeHeap(I:Longint; V:Longint);
var Ac:Longint;
begin
Ac := I;
Heap[I] := V;

While (Ac > 1) And (Heap[Ac Div 2] >= Heap[Ac]) Do Begin
  Swap (Heap[Ac Div 2], Heap[Ac]);
  Swap (IH[HI[Ac Div 2]], IH[HI[Ac]]);
  Swap (HI[Ac Div 2], HI[Ac]);
  Ac := Ac Div 2;
End;

While (Ac * 2 <= HC) Do Begin
  If Ac * 2 = HC Then Begin
    If Heap[Ac] >= Heap[Ac * 2] Then Begin
      Swap (Heap[Ac * 2], Heap[Ac]);
      Swap (IH[HI[Ac * 2]], IH[HI[Ac]]);
      Swap (HI[Ac * 2], HI[Ac]);
      Ac := Ac * 2;
    End Else
      Break;
  End Else Begin
    If Heap[Ac] >= Heap[Ac * 2] Then Begin
      If Heap[Ac] >= Heap[Ac * 2 + 1] Then Begin
        If Heap[Ac * 2] <= Heap[Ac * 2 + 1] Then Begin
          Swap (Heap[Ac * 2], Heap[Ac]);
          Swap (IH[HI[Ac * 2]], IH[HI[Ac]]);
          Swap (HI[Ac * 2], HI[Ac]);
          Ac := Ac * 2;
        End Else Begin
          Swap (Heap[Ac * 2 + 1], Heap[Ac]);
          Swap (IH[HI[Ac * 2 + 1]], IH[HI[Ac]]);
          Swap (HI[Ac * 2 + 1], HI[Ac]);
          Ac := Ac * 2 + 1;
        End;
      End Else Begin
        Swap (Heap[Ac * 2], Heap[Ac]);
        Swap (IH[HI[Ac * 2]], IH[HI[Ac]]);
        Swap (HI[Ac * 2], HI[Ac]);
        Ac := Ac * 2;
      End;
    End Else Begin
      If Heap[Ac] >= Heap[Ac * 2 + 1] Then Begin
        Swap (Heap[Ac * 2 + 1], Heap[Ac]);
        Swap (IH[HI[Ac * 2 + 1]], IH[HI[Ac]]);
        Swap (HI[Ac * 2 + 1], HI[Ac]);
        Ac := Ac * 2 + 1;
      End Else
        Break;
    End;
  End;
End;
end;

procedure DelHeap;
begin
Heap[1] := Heap[HC];
IH[HI[1]] := -1;
IH[HI[HC]] := 1;
HI[1] := HI[HC];
HC := HC - 1;

ChangeHeap (1, Heap[1]);
end;

var
  VS:Array[1..10000] Of Longint;
  D:Array[1..10000] Of Longint;

procedure Dijkstra(S:Longint);
var I, MinI:Longint;
begin
For I := 1 To N Do Begin
  Heap[I] := 2000000000;
  HI[I] := I;
  IH[I] := I;
  D[I] := 2000000000;
End;
HC := N;

ChangeHeap (S, 0);

While (HC > 0) Do Begin
  MinI := HI[1];

  I := VS[MinI];
  While (A[I] = MinI) Do Begin
    If IH[B[I]] > 0 Then
      If Heap[IH[B[I]]] > Heap[1] + L[I] Then
        ChangeHeap (IH[B[I]], Heap[1] + L[I]);
    I := I + 1;
  End;

  D[HI[1]] := Heap[1];
  DelHeap;
End;
end;

var
  oA, I:Longint;
  S, E:Longint;
begin
Assign (input, 'distance.in');
ReSet (input);
Readln (N, M);
Readln (S, E);
For I := 1 To M Do Begin
  Readln (input, A[I * 2 - 1], B[I * 2 - 1], L[I * 2 - 1]);
  A[I * 2] := B[I * 2 - 1];
  B[I * 2] := A[I * 2 - 1];
  L[I * 2] := L[I * 2 - 1];
End;
M := M * 2;
Close (input);

MergeSort (1, M);

FillChar (VS, SizeOf(VS), 0);
oA := 0;
For I := 1 To M Do Begin
  If A[I] <> oA Then
    VS[A[I]] := I;
  oA := A[I];
End;

For I := 1 To N Do
  If VS[I] = 0 Then VS[I] := 1;

Dijkstra(S);

Assign (output, 'distance.out');
ReWrite (output);
If D[E] >= 2000000000 Then
  Writeln (output, '-1')
Else
  Writeln (output, D[E]);
Close (output);
end.
